#!/usr/bin/perl
require 5;
use SNMP_Session;
use BER;
use strict;


sub snmp_get($@);

$SNMP_Session::suppress_warnings = 1;

my $ipv4_only_p = 0;
my $snmp_version = 1;

my $hostname = '172.17.39.1';
my $community = 'public';

my %ugly_oids = qw(sysDescr	1.3.6.1.2.1.1.1.0
		sysContact	1.3.6.1.2.1.1.4.0
		sysName       1.3.6.1.2.1.1.5.0
		sysLocation	1.3.6.1.2.1.1.6.0
		ipInDelivers  1.3.6.1.2.1.4.9.0
		ipInReceives  1.3.6.1.2.1.4.3.0
		);

my %pretty_oids;


foreach (keys %ugly_oids) {
    $ugly_oids{$_} = encode_oid (split (/\./, $ugly_oids{$_}));
    $pretty_oids{$ugly_oids{$_}} = $_;
}

srand();
my $session = ($snmp_version == 1)
    ? SNMPv1_Session->open ($hostname, $community, 161,
			    undef, undef, undef, undef,undef, $ipv4_only_p)
    : SNMPv2c_Session->open ($hostname, $community, 161,
			     undef, undef, undef, undef, undef, $ipv4_only_p)
    or die "Couldn't open SNMP session to $hostname: $SNMP_Session::errmsg";
snmp_get ($session, qw(sysDescr sysContact sysName sysLocation ipInDelivers ipInReceives));
$session->close ();
1;

sub snmp_get ($@) {
    my($session, @oids) = @_;
    my($response, $bindings, $binding, $value, $oid);
    grep ($_ = $ugly_oids{$_}, @oids);
    my $interf='';
    my $stroka='';
    if ($session->get_request_response (@oids)) {
	$response = $session->pdu_buffer;
	($bindings) = $session->decode_get_response ($response);
	print "Content-type: text/html\n\n";
	print "<html> <title> SNMP Management monitor </title> <body> <center><b>SNMP Management Monitor </b><hr><table cellpadding=1 cellspacing=1 border=2>";
	while ($bindings ne '') {
	    ($binding, $bindings) = decode_sequence ($bindings);
	    ($oid, $value) = decode_by_template ($binding, "%O%@");
	    print "<tr><td bgcolor=yellow><b>",$pretty_oids{$oid}, " </b></td> ";
	}
	print "</table></body></html>";
    } else {
	warn "SNMP problem: $SNMP_Session::errmsg\n";
    }
}


